<?php

namespace Drupal\click_a_role\Controller;
use Drupal\Core\Controller\ControllerBase;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;

/**
 * An example controller.
 */
class ClickARoleController extends ControllerBase {
  /**
   * Adds given roles to the current user
   */
  public function setRoles(Request $request) {
    $roles = $this->getRolesFromRequest($request);
    $user = \Drupal\user\Entity\User::load(\Drupal::currentUser()->id());
    foreach($roles->addRoles as $role) {
      if($this->handlingOfRoleIsAllowed($role)) {
        $user->addRole($role);
      }
    }
    foreach($roles->removeRoles as $role) {
      if($this->handlingOfRoleIsAllowed($role)) {
        $user->addRole($role);
      }
    }
    $user->save();
    return new JsonResponse([
      'data' => $roles,
      'method' => 'GET'
    ]);
  }

  function getRolesFromRequest(Request $request) {
    $content = $request->getContent();
    $roles = json_decode($content);
    return $roles;
  }

  function handlingOfRoleIsAllowed($role) {
    $roles = \Drupal::config('click_a_role.settings')->get('roles');
    return in_array($role, $roles);
  }
}
